org.apache.fop.afp.goca

## Class AbstractGraphicsDrawingOrderContainer

- java.lang.Object
- - org.apache.fop.afp.modca.AbstractAFPObject
  - - org.apache.fop.afp.modca.AbstractStructuredObject
    - - org.apache.fop.afp.modca.AbstractTripletStructuredObject
      - - org.apache.fop.afp.modca.AbstractNamedAFPObject
        - - org.apache.fop.afp.goca.AbstractGraphicsDrawingOrderContainer

All Implemented Interfaces:
  Completable, Startable, Streamable, StructuredData

Direct Known Subclasses:
  GraphicsChainedSegment, GraphicsData

    public abstract class AbstractGraphicsDrawingOrderContainer
    extends AbstractNamedAFPObject
    implements StructuredData, Completable, Startable

A base container of prepared structured AFP objects

### Nested Class Summary

### Nested classes/interfaces inherited from class org.apache.fop.afp.modca.AbstractAFPObject

`AbstractAFPObject.Category, AbstractAFPObject.Type`

### Field Summary

Fields
`protected List` `objects` list of objects contained within this container

### Fields inherited from class org.apache.fop.afp.modca.AbstractNamedAFPObject

`name`

### Fields inherited from class org.apache.fop.afp.modca.AbstractTripletStructuredObject

`triplets`

### Fields inherited from class org.apache.fop.afp.modca.AbstractAFPObject

`LOG, SF_CLASS, SF_HEADER_LENGTH`

### Constructor Summary

Constructors
`protected` `AbstractGraphicsDrawingOrderContainer()` Default constructor
`protected` `AbstractGraphicsDrawingOrderContainer(String name)` Named constructor

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `addAll(AbstractGraphicsDrawingOrderContainer graphicsContainer)` Adds all the contents of a given graphics container to this container
`void` `addObject(StructuredData object)` Adds a given graphics object to this container
`int` `getDataLength()` Returns the current data length
`boolean` `isComplete()` Returns true if this object is complete
`boolean` `isStarted()` Returns true if this object has started
`StructuredData` `removeLast()` Removes the last drawing order from this container and returns it
`void` `setComplete(boolean complete)` Sets whether or not this object is complete or not
`void` `setStarted(boolean started)` Sets whether or not this object has started or not
`protected void` `writeContent(OutputStream os)` Helper method to write the contents of the Object.
`protected void` `writeStart(OutputStream os)` Helper method to write the start of the Object.

### Methods inherited from class org.apache.fop.afp.modca.AbstractNamedAFPObject

`copySF, getName, getNameBytes, getNameLength, setName, toString`

### Methods inherited from class org.apache.fop.afp.modca.AbstractTripletStructuredObject

`addTriplet, addTriplets, getFullyQualifiedName, getTripletDataLength, getTriplets, hasTriplet, hasTriplets, setComment, setFullyQualifiedName, setFullyQualifiedName, setObjectClassification, writeTriplets`

### Methods inherited from class org.apache.fop.afp.modca.AbstractStructuredObject

`writeEnd, writeToStream`

### Methods inherited from class org.apache.fop.afp.modca.AbstractAFPObject

`copySF, truncate, writeChunksToStream, writeObjects`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### objects

    protected List objects

list of objects contained within this container

### Constructor Detail

#### AbstractGraphicsDrawingOrderContainer

    protected AbstractGraphicsDrawingOrderContainer()

Default constructor

#### AbstractGraphicsDrawingOrderContainer

    protected AbstractGraphicsDrawingOrderContainer(String name)

Named constructor

Parameters:
  `name` - the name of the container

### Method Detail

#### writeStart

    protected void writeStart(OutputStream os)
                       throws IOException

Helper method to write the start of the Object.

Overrides:
  `writeStart` in class `AbstractStructuredObject`
Parameters:
  `os` - The stream to write to
Throws:
  `IOException` - throws an I/O exception if one occurred

#### writeContent

    protected void writeContent(OutputStream os)
                         throws IOException

Helper method to write the contents of the Object.

Overrides:
  `writeContent` in class `AbstractStructuredObject`
Parameters:
  `os` - The stream to write to
Throws:
  `IOException` - throws an I/O exception if one occurred

#### addObject

    public void addObject(StructuredData object)

Adds a given graphics object to this container

Parameters:
  `object` - the structured data object

#### addAll

    public void addAll(AbstractGraphicsDrawingOrderContainer graphicsContainer)

Adds all the contents of a given graphics container to this container

Parameters:
  `graphicsContainer` - a graphics container

#### removeLast

    public StructuredData removeLast()

Removes the last drawing order from this container and returns it

Returns:
  the last drawing order from this container or null if empty

#### getDataLength

    public int getDataLength()

Returns the current data length

Specified by:
  `getDataLength` in interface `StructuredData`
Returns:
  the current data length of this container including all enclosed objects (and their containers)

#### setComplete

    public void setComplete(boolean complete)

Sets whether or not this object is complete or not

Specified by:
  `setComplete` in interface `Completable`
Parameters:
  `complete` - true if this object is complete

#### isComplete

    public boolean isComplete()

Returns true if this object is complete

Specified by:
  `isComplete` in interface `Completable`
Returns:
  true if this object is complete

#### isStarted

    public boolean isStarted()

Returns true if this object has started

Specified by:
  `isStarted` in interface `Startable`
Returns:
  true if this object has started

#### setStarted

    public void setStarted(boolean started)

Sets whether or not this object has started or not

Specified by:
  `setStarted` in interface `Startable`
Parameters:
  `started` - true if this object has started